package com.tzld.longarticle.recommend.server.service.rank;


import com.tzld.longarticle.recommend.server.model.Content;
import com.tzld.longarticle.recommend.server.util.TitleSimilarCheckUtil;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @author dyp
 */
public interface RankStrategy {

    RankResult rank(RankParam param);

    public static void deduplication(List<Content> result, Map<String, List<Content>> contentMap, String[] publishPool) {
        List<String> titles = new ArrayList<>();
        for (int i = 0; i < result.size(); i++) {
            if (TitleSimilarCheckUtil.isDuplicateContent(result.get(i).getTitle(), titles)) {
                if (i == 0) {
                    for (Content content : contentMap.get(publishPool[0])) {
                        if (!TitleSimilarCheckUtil.isDuplicateContent(content.getTitle(), titles)) {
                            result.set(i, content);
                            titles.add(content.getTitle());
                            break;
                        }
                    }
                } else if (i == 1) {
                    for (Content content : contentMap.get(publishPool[1])) {
                        if (!TitleSimilarCheckUtil.isDuplicateContent(content.getTitle(), titles)) {
                            result.set(i, content);
                            titles.add(content.getTitle());
                            break;
                        }
                    }
                } else {
                    for (Content content : contentMap.get(publishPool[2])) {
                        if (!TitleSimilarCheckUtil.isDuplicateContent(content.getTitle(), titles)) {
                            result.set(i, content);
                            titles.add(content.getTitle());
                            break;
                        }
                    }
                }
            } else {
                titles.add(result.get(i).getTitle());
            }
        }
    }

}
